#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#  Copyright (C) 2008 Wilson Pinto Júnior <wilson@openlanhouse.org>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import gobject

class Response(gobject.GObject):
    waiting = True
    done = False
    
    __gsignals__ = {'done': (gobject.SIGNAL_RUN_FIRST,
                             gobject.TYPE_NONE,
                            (gobject.TYPE_PYOBJECT,)),
                    }
    
    def __init__(self, id):
        self.__gobject_init__()
        self.id = id
    
    def get_value(self):
        if hasattr(self, 'value'):
            return self.value
        else:
            raise ResponseError('Response is not done')
    
    def set_value(self, value):
        self.value = value
        self.done = True
        self.waiting = False
        self.emit('done', self.value)